// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "EndlessVendetta/BountySystem/WaypointActor.h"
#include "GameFramework/Actor.h"
#include "BaseGadgetTutorial.generated.h"

DECLARE_DYNAMIC_MULTICAST_DELEGATE(FCompletedGadgetTutorial)

UCLASS()
class ENDLESSVENDETTA_API ABaseGadgetTutorial : public AActor
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditDefaultsOnly, Category = "Gadget Tutorial")
	TSubclassOf<AWaypointActor> WaypointClass;

	AWaypointActor* WaypointActor;
	
	UPROPERTY(EditDefaultsOnly, Category = "Gadget Tutorial")
	UTexture2D* WaypointIcon;

	void SpawnNewWaypoint(FVector Loc, FString Desc);

	
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:
	// Sets default values for this actor's properties
	ABaseGadgetTutorial();

	FCompletedGadgetTutorial CompletedGadgetTutorial;
	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	virtual void DestroyTutorial();
	

};
