// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BaseGadgetTutorial.h"
#include "VisionLinkTutorial.generated.h"

UCLASS()
class ENDLESSVENDETTA_API AVisionLinkTutorial : public ABaseGadgetTutorial
{
	GENERATED_BODY()

	bool PlayerInTutorialZone = false;

	bool PlayerWasInTutZone = false;

	void BeginPlay() override;

	void Tick(float DeltaSeconds) override;

	void DestroyTutorial() override;

protected:
	UPROPERTY(EditDefaultsOnly)
	FString GoToAreaWaypointDesc;
	UPROPERTY(EditDefaultsOnly)
	FString LookAtTargetWaypointDesc;
	UPROPERTY(EditDefaultsOnly)
	FString ResultWaypointDesc;
	
	UPROPERTY(BlueprintReadWrite)
	FVector GoToAreaWaypointLoc;
	UPROPERTY(BlueprintReadWrite)
	FVector LookAtTargetWaypointLoc;
	UPROPERTY(BlueprintReadWrite)
	FVector ResultWaypointLoc;

	UPROPERTY(BlueprintReadWrite)
	FVector TargetLoc;

	// Spawns enemies, sets up waypoint locs, and target loc
	UFUNCTION(BlueprintImplementableEvent)
	void SpawnEnemiesAndSetupDefaults();
	UFUNCTION(BlueprintImplementableEvent)
	void DespawnEnemies();
	
	UFUNCTION(BlueprintCallable)
	void PlayerEnteredTutorialZone()
	{
		PlayerInTutorialZone = true;
	}
	UFUNCTION(BlueprintCallable)
	void PlayerLeftTutorialZone()
	{
		PlayerInTutorialZone = false;
	}

	void FinishedTutorial();
};
